// English to tamil transliterator
// (C) 2007 Harishankar - all rights reserved

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

#include <iostream>
#include <fstream>

std::string eng_chars[] = 
	{ "`a", "`A", "`i", "`I", "`u", "`U", "`e", "`E", "^i", "`o", "`O", "^u", "k", "c", "T", "t", "p", "r", "y", "R", "L", "v", "z", "l", "g", "G", "N", "n", "m", "b", "s", "S", "j", "h", "~", "a", "i", "I", "u", "U", "e", "E", "A", "o", "O", "w", "x" } ;

std::string tam_chars[] =
	{ "\u0B85", "\u0B86", "\u0B87", "\u0B88", "\u0B89", "\u0B8A", "\u0B8E", "\u0B8F", "\u0B90", "\u0B92", "\u0B93", "\u0B94", "\u0B95", "\u0B9A", "\u0B9F", "\u0BA4", "\u0BAA", "\u0BB0", "\u0BAF", "\u0BB1", "\u0BB3", "\u0BB5", "\u0BB4", "\u0BB2", "\u0B99", "\u0B9E", "\u0BA3", "\u0BA8", "\u0BAE", "\u0BA9", "\u0BB8", "\u0BB7", "\u0B9C", "\u0BB9", "\u0BCD", "\u0BBE", "\u0BBF", "\u0BC0", "\u0BC1", "\u0BC2", "\u0BC6", "\u0BC7", "\u0BC8", "\u0BCA", "\u0BCB", "\u0BCC", "\u0B83" };

int convert_to_tamil (char* infile, char* outfile)
{
	std::fstream ipf (infile, std::ios::in);
	std::fstream opf (outfile, std::ios::out | std::ios::trunc);
	
	char iput_ch, iput_ch2;
	std::string oput_str;

	while ( ipf )
	{
		ipf.get (iput_ch);
		if (ipf.eof ()) break;

		if (iput_ch == '`' || iput_ch == '^')
		{
			ipf.get (iput_ch2);
			if (ipf.eof() ) break;
			std::string ips;
			ips.append (1, iput_ch);
			ips.append (1, iput_ch2);
			int flag = 1;
			for (int i = 0; i <= 11; i ++)
			{
				if (ips == eng_chars[i])
				{
					oput_str += tam_chars[i];
					flag = 0;
					break;
				}
			}
			if (flag == 1)
				oput_str += ips;
		}
		else
		{
			std::string ips;
			ips.append (1, iput_ch);
			int flag = 1;
			for (int i = 12; i <= 46; i ++)
			{
				if (ips == eng_chars[i])
				{
					oput_str += tam_chars[i];
					flag = 0;
					break;
				}
			}
			if (flag == 1)
				oput_str += ips;
		}
	}
	opf.write (oput_str.c_str(), oput_str.length());

	opf.close();
	ipf.close();
}

int main (int argc, char* argv[])
{
	if (argc < 3)
	{
		std::cout << "Usage: " << std::endl;
		std::cout << argv[0] << " <infile> <outfile>" << std::endl;
		return -2;
	}
	
	int ret = convert_to_tamil (argv[1], argv[2]);
	return ret;
}
